﻿using System;
using System.Collections.Generic;
using System.Data.Services.Client;
using System.Linq;
using System.Windows.Controls;
using ChartIntegrationApplication.NorthwindReference;
using Telerik.Windows.Controls.Charting;
using System.Windows.Browser;

namespace ChartIntegrationApplication
{
	public partial class Page : UserControl
	{
		public Page()
		{
			InitializeComponent();

			this.Loaded += Page_Loaded;
			
		}

		private void Page_Loaded(object sender, System.Windows.RoutedEventArgs e)
		{
			HtmlPage.RegisterScriptableObject("slChartPage", this);

			BeginATOMRequest();
		}

		private void BeginATOMRequest()
		{
			DataServiceContext context = new DataServiceContext(new Uri("NorthwindDataService.svc", UriKind.Relative));
			DataServiceQuery<Category_Sales_for_1997> query = context.CreateQuery<Category_Sales_for_1997>("Category_Sales_for_1997");
			query.BeginExecute(ATOMRequestCompleted, query);
		}

		private void ATOMRequestCompleted(IAsyncResult asyncResult)
		{
			DataServiceQuery<Category_Sales_for_1997> query = asyncResult.AsyncState as DataServiceQuery<Category_Sales_for_1997>;

			SeriesMapping seriesMapping = new SeriesMapping();
			seriesMapping.LegendLabel = "Sales (Thousands)";
			seriesMapping.SeriesDefinition = new BarSeriesDefinition();
			seriesMapping.SeriesDefinition.DefaultFormat = this.SeriesItemLabelFormat;

			ItemMapping itemMapping = new ItemMapping("CategorySales", DataPointMember.YValue);

			seriesMapping.ItemMappings.Add(itemMapping);
			RadChart1.SeriesMappings.Add(seriesMapping);

			List<Category_Sales_for_1997> list = query.EndExecute(asyncResult).ToList();
			RadChart1.ItemsSource = list;

			RadChart1.DefaultView.ChartArea.AxisY.DefaultFormat = this.AxisYLabelFormat;
			TickPointCollection tickPoints = RadChart1.DefaultView.ChartArea.AxisX.TickPoints;
			for (int i = 0; i < tickPoints.Count; i++)
			{
				TickPoint tickPoint = tickPoints[i];
				tickPoint.Label = list[i].CategoryName;
			}

		    RadChart1.DefaultView.ChartTitle.Content = this.ChartTitle;
		}

        [ScriptableMember]
        public string ChartTitle
        {
            get; 
            set;
        }

        [ScriptableMember]
        public string SeriesItemLabelFormat
        {
            get;
            set;
        }

        [ScriptableMember]
        public string AxisYLabelFormat
        {
            get;
            set;
        }
	}
}
